<?php

	/*
	Plugin Name: FormCraft Demo Add-On
	Plugin URI: http://ncrafts.net/
	Description: Demo Add-on for FormCraft
	Author: nCrafts
	Author URI: http://ncrafts.net
	Version: 1
	Text Domain: formcraft-demo
	*/

	// Tell FormCraft our add-on exists
	add_action('formcraft_addon_init', 'formcraft_demo_addon');
	function formcraft_demo_addon()
	{
		register_formcraft_addon( 'demo_addon_settings', 0, 'Demo Addon', 'DemoController');
	}

	// We load our JavaScript file on the form editor page
	add_action('formcraft_addon_scripts', 'formcraft_demo_addon_scripts');
	function formcraft_demo_addon_scripts() {
		wp_enqueue_script('fc-demo-addon-js', plugins_url( 'demo_form_builder.js', __FILE__ ));
	}

	// We show a simple text field in the add-on's settings
	function demo_addon_settings() {
		echo "<input style='margin: 20px 10%; width: 80%' placeholder='Banned Email Hosts' type='text' ng-model='Addons.DemoAddon.banned_hosts'>";
	}

	// We hook into form submissions to check the submitted form data, and throw an error if
	add_action('formcraft_before_save', 'formcraft_demo_addon_hook', 10, 4);
	function formcraft_demo_addon_hook($filtered_content, $form_meta, $raw_content, $integrations)
	{
		global $fc_final_response;
		$demo_addon_settings = formcraft_get_addon_data('DemoAddon', $filtered_content['Form ID']);

		// We check if we have specified any banned hosts in add-on settings. If yes, we save the list as an array: $banned_hosts
		if ( !empty($demo_addon_settings['banned_hosts']) )
		{
			$banned_hosts = strpos($demo_addon_settings['banned_hosts'], ',') > -1 ? explode(',', $demo_addon_settings['banned_hosts']) : array($demo_addon_settings['banned_hosts']);
			$banned_hosts = array_map('trim', $banned_hosts);
		}

		foreach ($raw_content as $key => $value) {
			// We loop through the fields to find fields with the label Email
			if ( $value['label'] == 'Email' )
			{
				foreach ($banned_hosts as $host) {
					// We loop through each of our banned hosts and check if the value of Email field contains an occurance of this
					if ( strpos($value['value'], '@'.$host) > -1 )
					{
						// If yes, we show this general error message
						$fc_final_response['failed'] = "There is an issue with your form";

						// We also show an error message with every such email field. Here, $value['identifier'] is the field ID
						$fc_final_response['errors'][$value['identifier']] = $host." is a banned host";
					}
				}
			}
		}
	}
	?>